"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.depositToVault = exports.getDepositToVaultInstructionDataSerializer = void 0;
const mpl_token_metadata_1 = require("@metaplex-foundation/mpl-token-metadata");
const mpl_toolbox_1 = require("@metaplex-foundation/mpl-toolbox");
const umi_1 = require("@metaplex-foundation/umi");
const serializers_1 = require("@metaplex-foundation/umi/serializers");
const hooked_1 = require("../../hooked");
const shared_1 = require("../shared");
function getDepositToVaultInstructionDataSerializer() {
    return (0, serializers_1.mapSerializer)((0, serializers_1.struct)([
        ['discriminator', (0, serializers_1.u8)()],
        ['amount', (0, serializers_1.u64)()],
    ], { description: 'DepositToVaultInstructionData' }), (value) => ({ ...value, discriminator: 2, amount: value.amount ?? 1 }));
}
exports.getDepositToVaultInstructionDataSerializer = getDepositToVaultInstructionDataSerializer;
// Instruction.
function depositToVault(context, input) {
    // Program ID.
    const programId = context.programs.getPublicKey('mplVault', 'VAULTGBXz4HaFrg7PcQDWBF3Aj4E1Q1mvWUrAAo64pM');
    // Accounts.
    const resolvedAccounts = {
        vault: {
            index: 0,
            isWritable: true,
            value: input.vault ?? null,
        },
        authority: {
            index: 1,
            isWritable: false,
            value: input.authority ?? null,
        },
        payer: {
            index: 2,
            isWritable: true,
            value: input.payer ?? null,
        },
        owner: {
            index: 3,
            isWritable: false,
            value: input.owner ?? null,
        },
        ownerToken: {
            index: 4,
            isWritable: true,
            value: input.ownerToken ?? null,
        },
        mint: { index: 5, isWritable: false, value: input.mint ?? null },
        metadata: {
            index: 6,
            isWritable: true,
            value: input.metadata ?? null,
        },
        edition: {
            index: 7,
            isWritable: false,
            value: input.edition ?? null,
        },
        ownerTokenRecord: {
            index: 8,
            isWritable: true,
            value: input.ownerTokenRecord ?? null,
        },
        vaultToken: {
            index: 9,
            isWritable: true,
            value: input.vaultToken ?? null,
        },
        systemProgram: {
            index: 10,
            isWritable: false,
            value: input.systemProgram ?? null,
        },
        sysvarInstructions: {
            index: 11,
            isWritable: false,
            value: input.sysvarInstructions ?? null,
        },
        tokenMetadataProgram: {
            index: 12,
            isWritable: false,
            value: input.tokenMetadataProgram ?? null,
        },
        splTokenProgram: {
            index: 13,
            isWritable: false,
            value: input.splTokenProgram ?? null,
        },
        splAtaProgram: {
            index: 14,
            isWritable: false,
            value: input.splAtaProgram ?? null,
        },
        authorizationRulesProgram: {
            index: 15,
            isWritable: false,
            value: input.authorizationRulesProgram ?? null,
        },
        authorizationRules: {
            index: 16,
            isWritable: false,
            value: input.authorizationRules ?? null,
        },
    };
    // Arguments.
    const resolvedArgs = { ...input };
    // Default values.
    if (!resolvedAccounts.authority.value) {
        resolvedAccounts.authority.value = context.identity;
    }
    if (!resolvedAccounts.payer.value) {
        resolvedAccounts.payer.value = context.payer;
    }
    if (!resolvedAccounts.owner.value) {
        resolvedAccounts.owner.value = context.identity;
    }
    if (!resolvedAccounts.ownerToken.value) {
        resolvedAccounts.ownerToken.value = (0, mpl_toolbox_1.findAssociatedTokenPda)(context, {
            mint: (0, shared_1.expectPublicKey)(resolvedAccounts.mint.value),
            owner: (0, shared_1.expectPublicKey)(resolvedAccounts.owner.value),
        });
    }
    if (!resolvedAccounts.metadata.value) {
        resolvedAccounts.metadata.value = (0, mpl_token_metadata_1.findMetadataPda)(context, {
            mint: (0, shared_1.expectPublicKey)(resolvedAccounts.mint.value),
        });
    }
    if (!resolvedAccounts.edition.value) {
        resolvedAccounts.edition = {
            ...resolvedAccounts.edition,
            ...(0, hooked_1.resolveMasterEditionWhenNonFungible)(context, resolvedAccounts, resolvedArgs, programId, false),
        };
    }
    if (!resolvedAccounts.ownerTokenRecord.value) {
        resolvedAccounts.ownerTokenRecord = {
            ...resolvedAccounts.ownerTokenRecord,
            ...(0, hooked_1.resolveOwnerTokenRecordWhenProgrammable)(context, resolvedAccounts, resolvedArgs, programId, true),
        };
    }
    if (!resolvedAccounts.vaultToken.value) {
        resolvedAccounts.vaultToken = {
            ...resolvedAccounts.vaultToken,
            ...(0, hooked_1.resolveVaultTokenWhenFungible)(context, resolvedAccounts, resolvedArgs, programId, true),
        };
    }
    if (!resolvedAccounts.systemProgram.value) {
        resolvedAccounts.systemProgram.value = context.programs.getPublicKey('splSystem', '11111111111111111111111111111111');
        resolvedAccounts.systemProgram.isWritable = false;
    }
    if (!resolvedAccounts.sysvarInstructions.value) {
        resolvedAccounts.sysvarInstructions.value = (0, umi_1.publicKey)('Sysvar1nstructions1111111111111111111111111');
    }
    if (!resolvedAccounts.tokenMetadataProgram.value) {
        resolvedAccounts.tokenMetadataProgram.value = context.programs.getPublicKey('mplTokenMetadata', 'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s');
        resolvedAccounts.tokenMetadataProgram.isWritable = false;
    }
    if (!resolvedAccounts.splTokenProgram.value) {
        resolvedAccounts.splTokenProgram.value = context.programs.getPublicKey('splToken', 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA');
        resolvedAccounts.splTokenProgram.isWritable = false;
    }
    if (!resolvedAccounts.splAtaProgram.value) {
        resolvedAccounts.splAtaProgram = {
            ...resolvedAccounts.splAtaProgram,
            ...(0, hooked_1.resolveSplAtaProgramWhenFungible)(context, resolvedAccounts, resolvedArgs, programId, false),
        };
    }
    if (!resolvedAccounts.authorizationRulesProgram.value) {
        resolvedAccounts.authorizationRulesProgram = {
            ...resolvedAccounts.authorizationRulesProgram,
            ...(0, hooked_1.resolveAuthorizationRulesProgram)(context, resolvedAccounts, resolvedArgs, programId, false),
        };
    }
    // Accounts in order.
    const orderedAccounts = Object.values(resolvedAccounts).sort((a, b) => a.index - b.index);
    // Keys and Signers.
    const [keys, signers] = (0, shared_1.getAccountMetasAndSigners)(orderedAccounts, 'programId', programId);
    // Data.
    const data = getDepositToVaultInstructionDataSerializer().serialize(resolvedArgs);
    // Bytes Created On Chain.
    const bytesCreatedOnChain = 0;
    return (0, umi_1.transactionBuilder)([
        { instruction: { keys, programId, data }, signers, bytesCreatedOnChain },
    ]);
}
exports.depositToVault = depositToVault;
//# sourceMappingURL=depositToVault.js.map