"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.setVaultRedeemer = exports.getSetVaultRedeemerInstructionDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const serializers_1 = require("@metaplex-foundation/umi/serializers");
const accounts_1 = require("../accounts");
const shared_1 = require("../shared");
const types_1 = require("../types");
function getSetVaultRedeemerInstructionDataSerializer() {
    return (0, serializers_1.mapSerializer)((0, serializers_1.struct)([
        ['discriminator', (0, serializers_1.u8)()],
        ['redeemerType', (0, types_1.getRedeemerTypeSerializer)()],
    ], { description: 'SetVaultRedeemerInstructionData' }), (value) => ({ ...value, discriminator: 5 }));
}
exports.getSetVaultRedeemerInstructionDataSerializer = getSetVaultRedeemerInstructionDataSerializer;
// Instruction.
function setVaultRedeemer(context, input) {
    // Program ID.
    const programId = context.programs.getPublicKey('mplVault', 'VAULTGBXz4HaFrg7PcQDWBF3Aj4E1Q1mvWUrAAo64pM');
    // Accounts.
    const resolvedAccounts = {
        vault: {
            index: 0,
            isWritable: true,
            value: input.vault ?? null,
        },
        authority: {
            index: 1,
            isWritable: false,
            value: input.authority ?? null,
        },
        redeemer: {
            index: 2,
            isWritable: true,
            value: input.redeemer ?? null,
        },
        payer: {
            index: 3,
            isWritable: true,
            value: input.payer ?? null,
        },
        systemProgram: {
            index: 4,
            isWritable: false,
            value: input.systemProgram ?? null,
        },
        auction: {
            index: 5,
            isWritable: false,
            value: input.auction ?? null,
        },
    };
    // Arguments.
    const resolvedArgs = { ...input };
    // Default values.
    if (!resolvedAccounts.authority.value) {
        resolvedAccounts.authority.value = context.identity;
    }
    if (!resolvedAccounts.redeemer.value) {
        resolvedAccounts.redeemer.value = (0, accounts_1.findAuctionRedeemerPda)(context, {
            vault: (0, shared_1.expectPublicKey)(resolvedAccounts.vault.value),
        });
    }
    if (!resolvedAccounts.payer.value) {
        resolvedAccounts.payer.value = context.payer;
    }
    if (!resolvedAccounts.systemProgram.value) {
        resolvedAccounts.systemProgram.value = context.programs.getPublicKey('splSystem', '11111111111111111111111111111111');
        resolvedAccounts.systemProgram.isWritable = false;
    }
    // Accounts in order.
    const orderedAccounts = Object.values(resolvedAccounts).sort((a, b) => a.index - b.index);
    // Keys and Signers.
    const [keys, signers] = (0, shared_1.getAccountMetasAndSigners)(orderedAccounts, 'programId', programId);
    // Data.
    const data = getSetVaultRedeemerInstructionDataSerializer().serialize(resolvedArgs);
    // Bytes Created On Chain.
    const bytesCreatedOnChain = 0;
    return (0, umi_1.transactionBuilder)([
        { instruction: { keys, programId, data }, signers, bytesCreatedOnChain },
    ]);
}
exports.setVaultRedeemer = setVaultRedeemer;
//# sourceMappingURL=setVaultRedeemer.js.map